/*
	SBPO : BuildNPrice 360vr.js
*/

function call_analytics(){}
var defaultImgCheck = false;
$.fn.panorama = function(options) {
	this.each(function(){
		if(!defaultImgCheck){
			var settings = {views_number: 144,views_columns: 36};
			var panoElement = this;
			var panoContainer = $(panoElement);
			var orig_src = $(this).attr("src");
			var loaded = 0;
			var pano_mouse_position_x;
			var pano_mouse_position_y;
			var pano_mouse_delta_x = 0;
			var pano_mouse_delta_y = 0;
			var pano_mouse_delta_y_old = 3;
			var pano_mouse_down = false;
			var pano_current_number;
			var pano_timer;
			var panoLoadingStop = false;
			var pano_width = parseInt(panoContainer.attr("width"));
			var pano_height = parseInt(panoContainer.attr("height"));
			pano_mouse_position_x = parseInt(pano_width/2);
			pano_mouse_position_y = parseInt(pano_height/2);
	
			this.addEventListener("touchstart", touchHandler, true);
			this.addEventListener("touchmove", touchHandler, true);
			this.addEventListener("touchend", touchHandler, true);
			this.addEventListener("touchcancel", touchHandler, true);
	
			panoContainer.bind("touchmove",function(e){
				e.preventDefault();
			});
			panoContainer.css("margin", "0 0 0 0").css("padding", "0 0 0 0").wrap('<div class="panorama" style="position: relative; margin: 0 auto; padding: 0; height: '+pano_height+'px; width: '+pano_width+'px; overflow: hidden;"></div>');
	
			if(options) $.extend(settings, options);
			panoContainer.after('<a class="panoLoadingStop" href="#" style="display: none; color: white; position: absolute; top: 5px; right: 5px; text-decoration: none;">[stop]</a>');
	
			if (settings.views_columns==settings.views_number) { // exterior
				panoContainer.after('<p class="loadingPersent"><span>0 %</span></p>');
			}
	
			var src_prefix = orig_src.substr(0, orig_src.lastIndexOf('_')+1);
			var src_number = parseInt(orig_src.substr(orig_src.lastIndexOf('_')+1));
			pano_current_number = src_number;
	
			var array_data = orig_src.split(".");
			var src_sufix = "."+array_data[array_data.length-1];
			
			
			
			// Loading Button
			//panoContainer.after('<p class="panoLoadingStart"><button class="btnPanoVRStart" role="button"><img src="/content/dam/hyundai/template_en/en/images/findacar/360vr/btn_start.png" alt="Start" />360° VR Start</button></p>');
			panoContainer.after('<p class="panoLoadingStart"><button class="btnPanoVRStart" role="button"><img src="/etc/designs/hyundai/template_en/en/images/common/btn_start.png" alt="Start" />360° VR Start</button></p>');
			panoContainer.parent().find(".panoLoadingStop").bind('click', function(){
				panoLoadingStop = true;
				return false;
			});
	
			
			var imgUrl = panoContainer.parent().find("img.panorama").attr("src");
			if(useLowImageYn == 'true') {
				src_sufix += lowImagePath + src_sufix;
			}
			
		
		
			$.ajax({
			     url: imgUrl,
			     type: 'HEAD',
			     async: true,
			     success: function () {
			    	 panoContainer.parent().bind('click', function(){
			 			call_analytics();
			 			if(!panoContainer.parent().hasClass("loadingEnd")){
			 				panoContainer.parent().addClass("loadingEnd");
			 				panoContainer.parent().css("cursor", "wait");
			 				panoContainer.parent().find(".panoLoadingStart").hide();
			 				panoContainer.parent().find(".loadingPersent").show();
	
			 				panoContainer.parent().find(".panoVues").remove();
			 				var many = 0;
			 				pano_timer = setTimeout(function(){
			 					clearTimeout(pano_timer);
			 					for (var i=0; i<settings.views_number; i++) {
			 						if (i!=src_number){
			 							panoContainer.after('<img class="panoVues vue'+i+'" src="'+src_prefix+i+src_sufix+'" style="visibility: hidden;" />');
			 							panoContainer.parent().find("img.vue"+i).bind('load', function(){
	
			 								loaded++;
	
			 								if (panoLoadingStop) {
			 									panoLoadingStop=false;
	
			 									panoContainer.parent().css("cursor", "default");
			 									panoContainer.parent().find(".loadingPersent").hide();
			 									panoContainer.parent().find(".panoLoadingStart").show();
			 									panoContainer.parent().find(".loadingPersent span").html('loading');
			 									pano_timer = setTimeout(function(){
			 										clearTimeout(pano_timer); window.stop();
			 									});
	
			 								}
	
			 								if (parseInt((loaded/settings.views_number)*100) > 90) {
			 									panoContainer.parent().css("cursor", "pointer");
			 									panoContainer.parent().find(".loadingPersent").hide();
			 									panoContainer.parent().find(".pano_loading_masque").hide();
			 									panoContainer.parent().bind('mousedown', function(e){
			 										pano_mouse_down = true;
			 										pano_mouse_position_x = e.clientX;
			 										pano_mouse_position_y = e.clientY;
			 										panoContainer.parent().css("cursor", "move");
			 										e.stopPropagation();
			 										return false;
			 									});
	
			 									panoContainer.parent().bind('mouseup', function(e){
			 										pano_mouse_down = false;
			 										$("div.panorama").css("cursor", "pointer");
			 										e.stopPropagation();
			 										return false;
			 									});
	
			 									panoContainer.parent().bind('mousemove', function(e){
			 										e.preventDefault();
			 										e.stopPropagation();
			 										if (pano_mouse_down) {
			 											pano_mouse_delta_x = parseInt((pano_mouse_position_x - e.clientX)/32);
			 											pano_mouse_delta_y = parseInt((pano_mouse_position_y - e.clientY)/32);
			 											if (pano_mouse_delta_x!=0||pano_mouse_delta_y!=0) {
			 												var pageCoords = "( " + e.pageX + ", " + e.pageY + " )";
			 												var clientCoords = "( " + e.clientX + ", " + e.clientY + " )";
	
			 												if (settings.views_columns==settings.views_number) { // exterior
			 													pano_current_number=pano_current_number - pano_mouse_delta_x - settings.views_columns*pano_mouse_delta_y;
			 													if (pano_current_number<0) {
			 														pano_current_number = settings.views_columns-1;
			 													}
			 													if (pano_current_number>(settings.views_number-1)) {
			 														pano_current_number = settings.views_number-settings.views_columns;
			 													}
			 												}
	
			 												panoContainer.attr('src', src_prefix+pano_current_number+src_sufix);
			 												pano_mouse_position_x= e.clientX;
			 												pano_mouse_position_y= e.clientY;
			 												if(pano_mouse_delta_y > 0){
			 													pano_mouse_delta_y_old = pano_mouse_delta_y_old+1;
			 													if(pano_mouse_delta_y_old > settings.views_number/settings.views_columns){
			 														pano_mouse_delta_y_old = settings.views_number/settings.views_columns;
			 													}
			 												}
			 												if(pano_mouse_delta_y < 0){
			 													pano_mouse_delta_y_old = pano_mouse_delta_y_old-1;
			 													if(pano_mouse_delta_y_old < 1){
			 														pano_mouse_delta_y_old = 1;
			 													}
			 												}
			 											}
			 										}
			 									});
			 								}
			 								else {
			 									panoContainer.parent().find(".loadingPersent span").html(parseInt((loaded/settings.views_number)*100) + " %");
			 								}
			 							});
			 						}
			 					}
			 				}, 500);
			 			}
			 			defaultImgCheck = false;
			 		});
			     },
			     error: function () {
			    	 var prvImgUrl = panoContainer.parent().find("img.panorama").attr("src");
			    	 var arrImgUrl = prvImgUrl.split("/");
			    	 
			    	 var defaultImgUrl = "";
			    	 for(var ii = 0; ii < arrImgUrl.length; ii++) {
			    		 if(ii >= 1 && ii <= 8){
			    			 defaultImgUrl += "/" + arrImgUrl[ii];
			    		 }else if(ii == 9){
			    			defaultImgUrl += "/" + arrImgUrl[ii] + "/" + arrImgUrl[ii] + ".jpg";
			    		 }
			    	 }
			    	 
			    	 panoContainer.parent().find(".panorama").attr("src", defaultImgUrl);
			    	 panoContainer.parent().find(".panoLoadingStart").remove();
			    	 
			    	 defaultImgCheck = true;
			     }
			});
		}
	});
};

var interiorViewer;
var panoramapreview;

function cubeExperience(cate,targetArr,color,option) {
	var orig_src = targetArr[color].option[option].img;
	var panoramaImg = targetArr[color].option[option].img;

	$(".experienceWrap .experiencePanoramaBox").empty();
	$(".experienceWrap .experience_panoramabox").empty();
	$(".experienceWrap .experience_large").empty();
	$(".experienceWrap .experience_option").empty();
	$(".experienceWrap .experience_option2").empty();
	$(".experienceWrap .experience_sort_Wrap").removeClass("hideBtn");

	var src_prefix = panoramaImg.substr(0, orig_src.lastIndexOf('_')+1);
	var src_sufix = panoramaImg.substr(orig_src.indexOf(src_number,0)+String(src_number).length);
	var src_number = parseInt(orig_src.substr(orig_src.lastIndexOf('_')+1));

	if (cate=="exterior") {
		// exterior
		// Ex / In Tab 변경
		$(".experienceWrap .category .tabExterior").addClass("active");
		$(".experienceWrap .category .tabInterior").removeClass("active");

		// 배경 복원
		$(".experienceWrap").removeClass("interiorWrap");

		$(".experienceWrap .experience_option2").addClass("wheel");
		if(INcolorName.length>0){
			$(".experienceWrap .experiencePanoramaBox.exterior").append('<img src="'+panoramaImg+'" class="panorama" width="1120" height="425" alt="" />');
			$(".experienceWrap .exterior img.panorama").panorama({views_number: 36,views_columns: 36});
		}else{
			$(".experienceWrap .experiencePanoramaBox.exterior").append('<img src="'+panoramaImg+'" class="panorama" width="1120" height="425" alt="" />');
			$(".experienceWrap .exterior img.panorama").panorama({views_number: 36,views_columns: 36});
		}
		$(".experienceWrap .cube_shadow_interior").hide();

	} else {
		// Interior
		panoramapreview = targetArr[color].option[option].preview;

		// Ex / In Tab 변경
		$(".experienceWrap .category .tabExterior").removeClass("active");
		$(".experienceWrap .category .tabInterior").addClass("active");

		// 배경 삭제
		$(".experienceWrap").addClass("interiorWrap");

		// Panorama Container Box 생성
		$(".experienceWrap .experiencePanoramaBox").append('<div id="panorama"></div>');

		// Mobile 용 코드 삽입
		$(".experienceWrap .experience_panoramabox").append('<div class="mobileOnly"><img src="/etc/designs/hyundai/ww/en/images/findacar/360vr/mobile_blank.png" alt=""></div>');

		// pannellum Viewer 생성
		//interiorViewer.destroy();
		interiorViewer = pannellum.viewer("panorama",{
			"panorama":panoramaImg,
			"preview":panoramapreview,
			"autoLoad":false,
			"showControls":false
		});

		$(".experienceWrap .cube_shadow_interior").show();

	}
}

function cubeExterienceCustomiz(cateX,color,option){
	var targetArr;
	var idx = color;
	
	if(cateX == "exterior") {
		targetArr = EXcolorName;
		$('.experienceWrap .experiencePanoramaBox').attr("class","experiencePanoramaBox exterior");
	} else {
		targetArr = INcolorName;
		$('.experienceWrap .experiencePanoramaBox').attr("class","experiencePanoramaBox interior");
	}
	
	if(targetArr.length > 0){
		cubeExperience(cateX, targetArr, color, option);
	}else if(cateX == "exterior") {
		var defaultImgUrl = '/content/dam/hyundai/template_en/en/images/common/360vr/'+product_code+"/"+product_code+".jpg";
		$(".experienceWrap .category .tabExterior").hide();
		$(".sbpoVr360Exterior .pipVrWrap .experience360vr .experience360VrimgArea .experiencePanoramaBox .panorama").html("<img src='' class='panorama'>");
		$(".sbpoVr360Exterior .pipVrWrap .experience360vr .experience360VrimgArea .experiencePanoramaBox .panorama img").attr("src", defaultImgUrl);
		$(".sbpoVr360Exterior .pipVrWrap .experience360vr .experience360VrimgArea .experiencePanoramaBox .panoLoadingStart").remove();
	}
}
function touchHandler(event)
{

	var touches = event.changedTouches,
		first = touches[0],
		type = "";

	switch(event.type)
	{
		case "touchstart": type = "mousedown"; break;
		case "touchstart": type = "mousedown"; break;
		case "touchmove":  type="mousemove"; break;
		case "touchend":   type="mouseup"; break;
		default: return;
	}

	var simulatedEvent = document.createEvent("MouseEvent");

	var mult = 2;

	if( navigator.userAgent.match(/Android/i) ) {
		mult = 10;
	}

	simulatedEvent.initMouseEvent(type, true, true, window, 1,
		first.screenX, first.screenY,
		(first.clientX * mult), (first.clientY * mult), false,
		false, false, false, 0/*left*/, null);
	first.target.dispatchEvent(simulatedEvent);
}

function functiontofindIndexByKeyValue(arraytosearch, key, valuetosearch) {

	for (var i = 0; i < arraytosearch.length; i++) {
		if (arraytosearch[i][key] == valuetosearch) {
			return i;
		}
	}
	return null;
}
